#include <avr/io.h>
#include <util/delay.h>

#define output(directions,pin) (directions |= pin) 	// set port direction for output
#define input(directions,pin) (directions &= (~pin))	// set port direction for input
#define set(port,pin) (port |= pin) 			// set port pin
#define clear(port,pin) (port &= (~pin)) 		// clear port pin
#define pin_test(pins,pin) (pins & pin) 		// test for port pin
#define led_delay() _delay_ms(100) 			// LED delay

#define input_port 	PORTB
#define input_direction DDRB
#define input_pin 	(1 << PB2)
#define input_pins 	PINB

#define led_port 	PORTA
#define led_direction 	DDRA
#define led_pin 	(1 << PA7)


int main(void) {

   // set clock divider to /1
   CLKPR = (1 << CLKPCE);
   CLKPR = (0 << CLKPS3) | (0 << CLKPS2) | (0 << CLKPS1) | (0 << CLKPS0);

   //
   // initialize pins
   //

   clear(led_port, led_pin);
   output(led_direction, led_pin);
   input(input_direction, input_pin); 	// OPTIONAL! all input for default
//   set(input_port, input_pin); 		// turn on pull-up: I have a pull-up resistor. I don't need to enable this.

   //
   // main loop
   //
   while (1) {
	while (0 != pin_test(input_pins,input_pin));
      		set(led_port, led_pin);
      		led_delay();
 	while (0 == pin_test(input_pins,input_pin));
      		clear(led_port, led_pin);
      		led_delay();
   }

}
